.\"     Title: l3gui
.\"    Author: 
.\" Generator: DocBook XSL Stylesheets v1.72.0 <http://docbook.sf.net/>
.\"      Date: 01/16/2008
.\"    Manual: 
.\"    Source: 
.\"
.TH "L3GUI" "1" "01/16/2008" "" ""
.\" disable hyphenation
.nh
.\" disable justification (adjust text to left margin only)
.ad l
.SH "NAME"
l3gui \- graphical environment for interacting with l3 programs and data.
.SH "SYNOPSIS"
l3gui [\-\-help | \-h] [\-\-version] [\-f FILE | \-\-file=FILE] [\-s STATEFILE | \-\-statefile=STATEFILE] [\-i | \-\-interactive] [\-d | \-\-developer]
.sp
.SH "DESCRIPTION"
The l3 language is an interpreted, lexically scoped language designed to automate much of the parameter and data handling of the type often encountered in experimental (scientific) computing. See l3lang(1) for a detailed language description.
.sp
The l3gui(1) command starts an interactive graphical interface for editing, viewing and executing l3 scripts and viewing the data produced by the scripts.
.sp
Standard facilities include interactive toplevels for l3 and Python, and a worksheet\-style interface for l3 scripts providing editing facilities and the usual open/edit/save options.
.sp
l3 introduces several new features to support use from a graphical interface; they are:
.sp
.RS 4
\h'-04'\(bu\h'+03'A script is used as its own data browser. Every expression is turned into an object with inspection facilities. Both the expression and the value(s) computed by the expression can be accessed through the script's text.
.RE
.RS 4
\h'-04'\(bu\h'+03'A data flow graph can be generated from a script. In this view, named data are emphasized, and data interdependencies shown. Loops cause no \(lqexplosion\(rq of the data flow graph.
.RE
.RS 4
\h'-04'\(bu\h'+03'Scripts can evolve, even after execution. The combination of need\-based evaluation, lexical scoping and persistence allows l3 scripts to
\fIevolve\fR; they can be added to without re\-running existing code, and references to all previouly computed data are available.
.RE
Lexical scoping allows for arbitrarily nested (static) namespaces and avoids name collisions. Also, every function call introduces a new (dynamic) scope, so multiple calls to the same function do not produce naming conflicts, even when file names are used.
.sp
Using these facilities, the typical l3 usage cycle is \&... \fBhere\fR
.sp
.SH "OPTIONS"
.PP
\-\-help, \-h
.RS 4
Print this documentation and exit.
.RE
.PP
\-\-version
.RS 4
show program's version number and exit
.RE
.PP
\-f FILE, \-\-file=FILE
.RS 4
Load this l3 script.
.RE
.PP
\-s STATEFILE, \-\-statefile=STATEFILE
.RS 4
Load this l3 state file.
.RE
.PP
\-i, \-\-interactive
.RS 4
Go to Python console on exit. This allows moving between Python and the gui. To restart the gui, use gtk.main()
.RE
.PP
\-d, \-\-developer
.RS 4
Import all l3 modules (from \&... import*) when using \-i. Allows for interactive updates.
.RE
.SH "AQUIRING PROGRAMS"
Text editing facilities in l3gui are minimal, and only intended for small modifications. Therefore, other ways to create new scripts for the l3gui are provided:
.sp
.SS "Copying from the procedure library"
When prepackaged functionality is provided for l3, the left canvas holds it in an outline tree. Select the parts of interest, copy them, and adjust parameters as described in the EDITING PROGRAMS section.
.sp
.SS "Importing from file or pasting text onto the canvas"
For writing larger scripts from scratch, using a text editor with support for Python programs is strongly recommended. See emacs(1) or vim(1). Once such a script is written (and ideally, tested on trivial data using Python), it can be imported via file > import script. Short script fragments can be pasted via mouse\-2.
.sp
\fBExample\ 1.\ Importing scripts or fragments.\fRpicture: ways of importing scripts and script fragments
.sp
Once imported, the script is treated as a structure, although the display still resembles the original text. Most expressions display in the original's text form, but source code lines are separated with a narrow marker. Note that the imported script is in a Program: block, while the pasted expression is not.
.sp
Every part of an expression can now be selected. See the selection example.
.sp
.SS "Collecting input and output from a toplevel"
For more interactive use, command\-line input can be used. Using the menu > edit > local console selection, an interactive l3 toplevel is run on the console l3gui was started from. At the same time, a new empty Program: is inserted on the canvas. Expressions can be entered at the toplevel in the same way as in Python, and are evaluated when complete. If evaluation succeeds, the expression is appended to the Program: and the l3 structural manipulations are then available; in particular, the value(s) may be examined.
.sp
\fBExample\ 2.\ Using the toplevel with the gui.\fRThe toplevel is is started and expressions tried. The Program: accumulates the command history.
.sp
.SH "EDITING PROGRAMS"
The editing facilities of l3gui are focused on structural editing \(em insertion and removal of expressions, and the selection of values associated with expressions. These operations can be done any time, but are most useful after a script has been run (whether successfully or not), and allow incremental refinement of scripts.
.sp
\fBExample\ 3.\ Selection of (sub)expressions.\fRAs a trivial sample, pasting 1 + 2 displays 1 + 2. Now, selecting (via Mouse\-1) the 1 highlights just 1; selecting the + highlights the whole expression.
.sp
Every expression has an associated menu, accessed via Mouse\-3. Pull up the menu on the previously imported script, and select Run program. The script is executed, and its data ready for inspection; see the interaction section.
.sp
Only a Program: expression has a Run menu entry, so to execute a fragment of code that is not already inside a program requires putting it in one.
.sp
\fBExample\ 4.\ Construction of a program from fragments.\fRTo evaluate the expression 3 \- 2, add a Program: block to the canvas.
.sp
Select the expression via mouse\-1, and insert it into the program by pressing mouse\-2 on the grey separator
.sp
Occasionally, a short expression needs to be edited textually. By double\-clicking mouse\-1 on the expression, a small editor is popped up. In the editor, ESC or Cancel abort the edit, while Ctrl\-Enter or Ok commits the change.
.sp
Note that replacing call(1,2) with call(1,2) (the same \fBtext\fR) and pressing Ok is not the same as pressing Cancel. Replacing an expression \fBalways\fR removes the original inserts a the new one, even if the text is identical. And a new expression will be evaluated again when its containing Program: is run. See incremental evaluation.
.sp
.SH "INTERACTING WITH DATA"
Data are the result of expression evaluation. Attaching a datum to the expression that created it provides a natural way of locating the datum.
.sp
\fBExample\ 5.\ Selection of datum value.\fRPaste and run the program
.sp
.sp
.RS 4
.nf
Program:
    3 \- 2
.fi
.RE
Then select the \- menu (mouse\-3) and > dump values. Note that there is only one value, 1.
.sp
Expressions inside loops or tail calls may have more than one value, so every expression's menu has a dump values entry that prints all values associated with the expression to the terminal.
.sp
\fBExample\ 6.\ Selection of data values.\fRPaste and run the program
.sp
.sp
.RS 4
.nf
Program:
    for ii in [1,2,3]:
        ii \- 3
.fi
.RE
Then select the \- menu (mouse\-3) and > dump values. Note that there are now three values.
.sp
Instead of printing values, values can be wrapped as l3 expressions and inserted on the canvas, using the insert values as menu entry. In this form, values are ready to be used in or by other scripts.
.sp
Wrapped values are referenced, not copied.
.sp
\fBExample\ 7.\ Insertion of data values.\fRPaste and run the program
.sp
.sp
.RS 4
.nf
Program:
    for ii in [1,2,3]:
        ii \- 3
.fi
.RE
To import these values for further editing, select the \- menu (mouse\-3) and > insert values (l3). This inserts a list containing the values.
.sp
When a data to PNG converter is available, the bitmap image is displayed by l3gui instead of the textual representation of the data. These custom viewers are never interactive, and are intended to provide a quantitative view only.
.sp
\fBExample\ 8.\ Insertion of data thumbnails.\fRThe eman data list sample
.sp
For more detailed data examination or manipulation, external processes can be called on selected data. l3 makes no attempt at tracking the data passed out this way; instead, the data is assumed CONSTANT. If an external program is used to modify data, the new data should be written to a new file. The l3 subdir: command can help with this, by creating a new, empty directory in which to put data.
.sp
\fBExample\ 9.\ Operating on data using external processes.\fRUsing chimera on a volume.
.sp
.SH "POST\-EXECUTION EDITING"
As described in l3lang(1), execution of a l3 program is incremental; an expression is only executed if it is out\-of\-date or new.
.sp
When an error is encountered in evaluating an expression, execution stops and the expression's status is unchanged \(em it remains \(lqnew\(rq.
.sp
Thus, if an error is caused by a faulty expression, the expression can be replaced with a correct one, and the program re\-run without time loss.
.sp
\fBExample\ 10.\ Fixing a run\-time error inside a program\fRsimple wrong command near the end of the program.
.sp
A program that ran successfully may reveal the need for more information. Instead of writing a new script replicating many of the same iterations and data references, the new relevant expressions can be added to the existing program, and the resulting program run. In the re\-run, only this additions are executed.
.sp
\fBExample\ 11.\ Evolving a script, post\-execution.\fRAdditions execute in the environment of the program, just as the original expressions. Thus, there is no need to rewrite loops, copy files, or introduce new file names.
.sp
.PP
\fBNote on make(1)\fR. This is similar to the behavior of make(1), in which targets are only updated when their dependencies require it. Unlike make(1),
.RS 4
\h'-04'\(bu\h'+03'there is only one \(lqtarget\(rq, the successfull execution of the program, and
.RE
.RS 4
\h'-04'\(bu\h'+03'there is no search for prerequisites; variables must be bound before use.
.RE
.SH "ERRORS"
Errors in scripts simply return control to the user.
.sp
.SH "EXAMPLES"
See $L3HOME/examples
.sp
.SH "FILES"
~/.l3lang/l3rc, ./.l3rc
.sp
.SH "ENVIRONMENT VARIABLES"
.TS
tab(:);
l l
l l.
T{
L3HOME
.sp
T}:T{
Directory containing l3lang/ and l3gui/
.sp
T}
T{
EDITOR
.sp
T}:T{
The executable name of the external editor to use.
.sp
T}
.TE
.sp
.SH "SEE ALSO"
l3lang(1), l3gui(1)
.sp
.SH "AUTHOR"
Michael Hohn, mhhohn@users.sf.net
.sp
.SH "COPYING"
Copyright \(co 2004\-8 Lawrence Berkeley National Laboratory. l3 is released under the BSD license. See license.txt for details.
.sp
